From e7419ca8bf79df22b3d6e70379e31e785d654cbe Mon Sep 17 00:00:00 2001
From: Marek Habersack <grendel@twistedcode.net>
Date: Wed, 24 Nov 2010 20:33:09 +0100
Subject: [PATCH] [asp.net] Normalization of cryptographic uses in asp.net.
 Backport of commit a22389fde254675e52a9da9c9bcd18afdec29d33
     Normalization of cryptographic uses in asp.net

    * System.Web.Configuration_2.0/MachineKeyRegistryStorage.cs:
    Remove key length check and generic key generation.

    * System.Web.Configuration_2.0/MachineKeySection.cs: Add support for 4.0
    ValidationAlgorithm and the use of custom algorithms (validation and
    decryption). Allow the use of any, valid, key length (based on the
    algorithm). Let each algorithm creates its own key (e.g. special needs,
    default length...)

    * System.Web.Configuration_2.0/MachineKeySectionUtils.cs: Remove key
    generation (from random) code and 192bits key length hack (won't work
    with custom algorithms). Add support for new (4.0) algorithms, including
    custom ones. Provide uniform/shared code to Encrypt/Decrypt, Sign/Verify
    and EncryptSign/VerifyDecrypt using MachineKeySection data.

    * System.Web.Configuration_2.0/MachineKeyValidation.cs: Add new (4.0)
    values.

    * System.Web.Configuration_2.0/MachineKeyValidationConverter.cs: Add
    support for new (4.0) algorithms.

    * System.Web.Handlers/AssemblyResourceLoader.cs: Use the new common
    cryptographic code and base64 the encrypted data.

    * System.Web.Security/FormsAuthentication.cs: Use the new common
    cryptographic code and base64 the signed and/or encrypted data.

    * System.Web.Security/MembershipHelper.cs: Use the new common
    cryptographic code - this should be 100% compatible with existing data.

    * System.Web.Security/RolePrincipal.cs: Use the new common cryptographic
    code.

    * System.Web.Security/SqliteMembershipProvider.cs: Adapt code for
    internal API change.
---
 mcs/class/System.Web/Assembly/AssemblyInfo.cs      |    2 +
 .../System.Web.Configuration/MachineKeyConfig.cs   |  198 ++++++----
 .../MachineKeyRegistryStorage.cs                   |   57 +---
 .../MachineKeyValidation.cs                        |   12 +-
 .../MachineKeyCompatibilityMode.cs                 |   40 ++
 .../MachineKeySection.cs                           |  210 +++++++++-
 .../MachineKeySectionUtils.cs                      |  442 +++++++++++++++-----
 .../MachineKeyValidationConverter.cs               |   70 +++-
 .../System.Web.Handlers/AssemblyResourceLoader.cs  |   78 +---
 .../System.Web.Security/FormsAuthentication.cs     |  167 +-------
 .../System.Web.Security/MembershipProvider.cs      |   46 +--
 .../System.Web.Security/RolePrincipal.cs           |   93 +----
 .../System.Web.Security/SqlMembershipProvider.cs   |   17 +-
 .../SqliteMembershipProvider.cs                    |    2 +-
 .../System.Web.SessionState/SessionId.cs           |   23 +-
 mcs/class/System.Web/System.Web.UI/LosFormatter.cs |   54 ++-
 .../System.Web.UI/ObjectStateFormatter.cs          |  156 ++++----
 mcs/class/System.Web/System.Web.UI/Page.cs         |   69 ---
 mcs/class/System.Web/System.Web.dll.sources        |    1 +
 mcs/class/System.Web/System.Web_test.dll.sources   |    2 +
 .../MachineKeySectionTest.cs                       |  158 +++++++
 .../MachineKeySectionUtilsTest.cs                  |  310 ++++++++++++++
 .../MachineKeyValidationConverterTest.cs           |   84 ++++-
 .../System.Web.Security/FormsAuthenticationTest.cs |   10 +
 .../Test/System.Web.Security/RolePrincipalTest.cs  |    4 +-
 .../Test/System.Web.UI/LosFormatterTest.cs         |  148 +++++++-
 .../Test/System.Web.UI/ObjectStateFormatterTest.cs |   16 +-
 .../System.Web/net_4_0_System.Web.dll.sources      |    1 +
 28 files changed, 1702 insertions(+), 768 deletions(-)
 create mode 100644 mcs/class/System.Web/System.Web.Configuration_2.0/MachineKeyCompatibilityMode.cs
 create mode 100644 mcs/class/System.Web/Test/System.Web.Configuration/MachineKeySectionTest.cs
 create mode 100644 mcs/class/System.Web/Test/System.Web.Configuration/MachineKeySectionUtilsTest.cs

diff --git a/mcs/class/System.Web/Assembly/AssemblyInfo.cs b/mcs/class/System.Web/Assembly/AssemblyInfo.cs
index b1e6f1e..7c174a2 100644
--- a/mcs/class/System.Web/Assembly/AssemblyInfo.cs
+++ b/mcs/class/System.Web/Assembly/AssemblyInfo.cs
@@ -69,6 +69,8 @@ using System.Web.UI;
 [assembly: InternalsVisibleTo ("System.Web.DynamicData, PublicKey=0024000004800000940000000602000000240000525341310004000001000100b5fc90e7027f67871e773a8fde8938c81dd402ba65b9201d60593e96c492651e889cc13f1415ebb53fac1131ae0bd333c5ee6021672d9718ea31a8aebd0da0072f25d87dba6fc90ffd598ed4da35e44c398c454307e8e33b8426143daec9f596836f97c8f74750e5975c64e2189f45def46b2a2b1247adc3652bf5c308055da9")]
 
 [assembly: InternalsVisibleTo ("SystemWebTestShim, PublicKey=0024000004800000940000000602000000240000525341310004000001000100b5fc90e7027f67871e773a8fde8938c81dd402ba65b9201d60593e96c492651e889cc13f1415ebb53fac1131ae0bd333c5ee6021672d9718ea31a8aebd0da0072f25d87dba6fc90ffd598ed4da35e44c398c454307e8e33b8426143daec9f596836f97c8f74750e5975c64e2189f45def46b2a2b1247adc3652bf5c308055da9")]
+[assembly: InternalsVisibleTo ("System.Web_test_net_2_0, PublicKey=0024000004800000940000000602000000240000525341310004000001000100b5fc90e7027f67871e773a8fde8938c81dd402ba65b9201d60593e96c492651e889cc13f1415ebb53fac1131ae0bd333c5ee6021672d9718ea31a8aebd0da0072f25d87dba6fc90ffd598ed4da35e44c398c454307e8e33b8426143daec9f596836f97c8f74750e5975c64e2189f45def46b2a2b1247adc3652bf5c308055da9")]
+[assembly: InternalsVisibleTo ("System.Web_test_net_4_0, PublicKey=0024000004800000940000000602000000240000525341310004000001000100b5fc90e7027f67871e773a8fde8938c81dd402ba65b9201d60593e96c492651e889cc13f1415ebb53fac1131ae0bd333c5ee6021672d9718ea31a8aebd0da0072f25d87dba6fc90ffd598ed4da35e44c398c454307e8e33b8426143daec9f596836f97c8f74750e5975c64e2189f45def46b2a2b1247adc3652bf5c308055da9")]
 #endif
 #endif
 
diff --git a/mcs/class/System.Web/System.Web.Configuration/MachineKeyRegistryStorage.cs b/mcs/class/System.Web/System.Web.Configuration/MachineKeyRegistryStorage.cs
index c6f1d52..52bc5b3 100644
--- a/mcs/class/System.Web/System.Web.Configuration/MachineKeyRegistryStorage.cs
+++ b/mcs/class/System.Web/System.Web.Configuration/MachineKeyRegistryStorage.cs
@@ -28,8 +28,6 @@
 // WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 //
 
-using System;
-using System.Security.Cryptography;
 using Microsoft.Win32;
 
 namespace System.Web.Configuration
@@ -42,9 +40,6 @@ namespace System.Web.Configuration
 			Encryption
 		};
 
-		const int encryptionKeyLength = 64;
-		const int validationKeyLength = 64;
-		
 		static string keyEncryption;
 		static string keyValidation;
 		
@@ -63,30 +58,15 @@ namespace System.Web.Configuration
 		
 		public static byte[] Retrieve (KeyType kt)
 		{
-			byte[] ret = GetKey (kt);
-			if (ret == null) {
-				ret = Generate (kt);
-				if (ret != null)
-					Store (ret, kt);
-			}
-			
-			return ret;
-		}
-
-		static byte[] GetKey (KeyType kt)
-		{
 			string key = null;
-			int len;
 			
 			switch (kt) {
 				case KeyType.Validation:
 					key = keyValidation;
-					len = validationKeyLength;
 					break;
 
 				case KeyType.Encryption:
 					key = keyEncryption;
-					len = validationKeyLength;
 					break;
 
 				default:
@@ -107,11 +87,7 @@ namespace System.Web.Configuration
 
 			if (o == null || o.GetType () != typeof (byte[]))
 				return null;
-			byte[] ret = (byte[])o;
-			if (ret.Length != len)
-				return null;
-
-			return ret;
+			return (byte[]) o;
 		}
 
 		static RegistryKey OpenRegistryKey (string path, bool write)
@@ -134,23 +110,19 @@ namespace System.Web.Configuration
 			return ret;
 		}
 		
-		static void Store (byte[] buf, KeyType kt)
+		public static void Store (byte[] buf, KeyType kt)
 		{
 			if (buf == null)
 				return;
 			
 			string key = null;
-			int len;
-			
 			switch (kt) {
 				case KeyType.Validation:
 					key = keyValidation;
-					len = validationKeyLength;
 					break;
 
 				case KeyType.Encryption:
 					key = keyEncryption;
-					len = validationKeyLength;
 					break;
 
 				default:
@@ -160,9 +132,6 @@ namespace System.Web.Configuration
 			if (key == null)
 				return;
 
-			if (buf.Length != len)
-				throw new ArgumentException ("Key has invalid length");
-
 			try {
 				using (RegistryKey rk = OpenRegistryKey (key, true)) {
 #if NET_2_0
@@ -180,27 +149,5 @@ namespace System.Web.Configuration
 				throw new ApplicationException ("Failed to store encryption key in the registry.", ex);
 			}
 		}
-
-		static byte[] Generate (KeyType kt)
-		{
-			RandomNumberGenerator rng = RandomNumberGenerator.Create ();
-			byte[] ret = null;
-			
-			switch (kt) {
-				case KeyType.Validation:
-					ret = new byte [validationKeyLength];
-					break;
-
-				case KeyType.Encryption:
-					ret = new byte [encryptionKeyLength];
-					break;
-
-				default:
-					throw new ArgumentException ("Unknown key type.");
-			}
-			
-			rng.GetBytes (ret);
-			return ret;
-		}
 	}
 }
diff --git a/mcs/class/System.Web/System.Web.Configuration/MachineKeyValidation.cs b/mcs/class/System.Web/System.Web.Configuration/MachineKeyValidation.cs
index a7b7515..eb7dfe1 100644
--- a/mcs/class/System.Web/System.Web.Configuration/MachineKeyValidation.cs
+++ b/mcs/class/System.Web/System.Web.Configuration/MachineKeyValidation.cs
@@ -23,11 +23,9 @@
 // OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
 // WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 //
-// Copyright (C) 2004 Novell, Inc (http://www.novell.com)
+// Copyright (C) 2004, 2010 Novell, Inc (http://www.novell.com)
 //
 
-using System.Resources;
-
 namespace System.Web.Configuration
 {
 #if NET_2_0
@@ -40,7 +38,13 @@ namespace System.Web.Configuration
 		MD5 = 0,
 		SHA1 = 1,
 		TripleDES = 2,
-		AES = 3
+		AES = 3,
+#if NET_4_0
+		HMACSHA256 = 4,
+		HMACSHA384 = 5,
+		HMACSHA512 = 6,
+		Custom = 7
+#endif
 	}
 }
 
diff --git a/mcs/class/System.Web/System.Web.Configuration_2.0/MachineKeyCompatibilityMode.cs b/mcs/class/System.Web/System.Web.Configuration_2.0/MachineKeyCompatibilityMode.cs
new file mode 100644
index 0000000..5581143
--- /dev/null
+++ b/mcs/class/System.Web/System.Web.Configuration_2.0/MachineKeyCompatibilityMode.cs
@@ -0,0 +1,40 @@
+//
+// System.Web.Configuration.MachineKeyCompatibilityMode
+//
+// Authors:
+//	Sebastien Pouliot  <sebastien@ximian.com>
+//
+// Copyright (C) 2010 Novell, Inc (http://www.novell.com)
+//
+// Permission is hereby granted, free of charge, to any person obtaining
+// a copy of this software and associated documentation files (the
+// "Software"), to deal in the Software without restriction, including
+// without limitation the rights to use, copy, modify, merge, publish,
+// distribute, sublicense, and/or sell copies of the Software, and to
+// permit persons to whom the Software is furnished to do so, subject to
+// the following conditions:
+// 
+// The above copyright notice and this permission notice shall be
+// included in all copies or substantial portions of the Software.
+// 
+// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
+// EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
+// MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
+// NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
+// LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
+// OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
+// WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
+//
+
+#if NET_4_0
+
+namespace System.Web.Configuration {
+
+	public enum MachineKeyCompatibilityMode {
+		Framework20SP1 = 0,
+		Framework20SP2 = 1
+	}
+}
+
+#endif
+
diff --git a/mcs/class/System.Web/System.Web.Configuration_2.0/MachineKeySection.cs b/mcs/class/System.Web/System.Web.Configuration_2.0/MachineKeySection.cs
index 193b9c2..c193e74 100644
--- a/mcs/class/System.Web/System.Web.Configuration_2.0/MachineKeySection.cs
+++ b/mcs/class/System.Web/System.Web.Configuration_2.0/MachineKeySection.cs
@@ -3,8 +3,9 @@
 //
 // Authors:
 //	Chris Toshok (toshok@ximian.com)
+//	Sebastien Pouliot  <sebastien@ximian.com>
 //
-// (c) Copyright 2005 Novell, Inc (http://www.novell.com)
+// (c) Copyright 2005, 2010 Novell, Inc (http://www.novell.com)
 //
 
 //
@@ -28,13 +29,13 @@
 // WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 //
 
+#if NET_2_0
+
 using System;
 using System.ComponentModel;
 using System.Configuration;
 using System.Security.Cryptography;
 
-#if NET_2_0
-
 namespace System.Web.Configuration {
 
 	public sealed class MachineKeySection : ConfigurationSection
@@ -44,6 +45,10 @@ namespace System.Web.Configuration {
 		static ConfigurationProperty validationProp;
 		static ConfigurationProperty validationKeyProp;
 		static ConfigurationPropertyCollection properties;
+		static MachineKeyValidationConverter converter = new MachineKeyValidationConverter ();
+#if NET_4_0
+		MachineKeyValidation validation;
+#endif
 
 		static MachineKeySection ()
 		{
@@ -55,10 +60,17 @@ namespace System.Web.Configuration {
 								       PropertyHelper.WhiteSpaceTrimStringConverter,
 								       PropertyHelper.NonEmptyStringValidator,
 								       ConfigurationPropertyOptions.None);
-			validationProp = new ConfigurationProperty ("validation", typeof (MachineKeyValidation), MachineKeyValidation.SHA1,
-								    new MachineKeyValidationConverter (),
+#if NET_4_0
+			validationProp = new ConfigurationProperty ("validation", typeof (string), "HMACSHA256",
+								    PropertyHelper.WhiteSpaceTrimStringConverter,
+								    PropertyHelper.NonEmptyStringValidator,
+								    ConfigurationPropertyOptions.None);
+#else
+			validationProp = new ConfigurationProperty ("validation", typeof (MachineKeyValidation), 
+								    MachineKeyValidation.SHA1, converter,
 								    PropertyHelper.DefaultValidator,
 								    ConfigurationPropertyOptions.None);
+#endif
 			validationKeyProp = new ConfigurationProperty ("validationKey", typeof (string), "AutoGenerate,IsolateApps",
 								       PropertyHelper.WhiteSpaceTrimStringConverter,
 								       PropertyHelper.NonEmptyStringValidator,
@@ -71,12 +83,30 @@ namespace System.Web.Configuration {
 			properties.Add (validationProp);
 			properties.Add (validationKeyProp);
 
-			MachineKeySectionUtils.AutoGenKeys ();
+			Config.AutoGenerate (MachineKeyRegistryStorage.KeyType.Encryption);
+			Config.AutoGenerate (MachineKeyRegistryStorage.KeyType.Validation);
 		}
 
+#if NET_4_0
+		public MachineKeySection ()
+		{
+			// get DefaultValue from ValidationAlgorithm
+			validation = (MachineKeyValidation) converter.ConvertFrom (null, null, ValidationAlgorithm);
+		}
+
+		[MonoTODO]
+		public MachineKeyCompatibilityMode CompatibilityMode {
+			get; set;
+		}
+#endif
+
 		protected override void Reset (ConfigurationElement parentElement)
 		{
 			base.Reset (parentElement);
+			decryption_key = null;
+			validation_key = null;
+			decryption_template = null;
+			validation_template = null;
 		}
 
 		[TypeConverter (typeof (WhiteSpaceTrimStringConverter))]
@@ -84,7 +114,10 @@ namespace System.Web.Configuration {
 		[ConfigurationProperty ("decryption", DefaultValue = "Auto")]
 		public string Decryption {
 			get { return (string) base [decryptionProp];}
-			set { base[decryptionProp] = value; }
+			set {
+				decryption_template = MachineKeySectionUtils.GetDecryptionAlgorithm (value);
+				base[decryptionProp] = value;
+			}
 		}
 
 		[TypeConverter (typeof (WhiteSpaceTrimStringConverter))]
@@ -94,16 +127,46 @@ namespace System.Web.Configuration {
 			get { return (string) base [decryptionKeyProp];}
 			set {
 				base[decryptionKeyProp] = value;
-				MachineKeySectionUtils.SetDecryptionKey (value);
+//				SetDecryptionKey (value);
 			}
 		}
 
+#if NET_4_0
+		// property exists for backward compatibility
+		public MachineKeyValidation Validation {
+			get { return validation; }
+			set {
+				if (value == MachineKeyValidation.Custom)
+					throw new ArgumentException ();
+//				ValidationAlgorithm = value.ToString ();
+			}
+		}
+
+		[StringValidator (MinLength = 1)]
+		[TypeConverter (typeof (WhiteSpaceTrimStringConverter))]
+		[ConfigurationProperty ("validation", DefaultValue = "HMACSHA256")]
+		public string ValidationAlgorithm {
+			get { return (string) base [validationProp];}
+			set {
+				if (value == null)
+					return;
+
+				if (value.StartsWith ("alg:"))
+					validation = MachineKeyValidation.Custom;
+				else
+					validation = (MachineKeyValidation) converter.ConvertFrom (null, null, value);
+
+				base[validationProp] = value;
+			}
+		}
+#else
 		[TypeConverter (typeof (MachineKeyValidationConverter))]
 		[ConfigurationProperty ("validation", DefaultValue = "SHA1")]
 		public MachineKeyValidation Validation {
 			get { return (MachineKeyValidation) base [validationProp];}
 			set { base[validationProp] = value; }
 		}
+#endif
 
 		[TypeConverter (typeof (WhiteSpaceTrimStringConverter))]
 		[StringValidator (MinLength = 1)]
@@ -112,13 +175,142 @@ namespace System.Web.Configuration {
 			get { return (string) base [validationKeyProp];}
 			set {
 				base[validationKeyProp] = value;
-				MachineKeySectionUtils.SetValidationKey (value);
+//				SetValidationKey (value);
 			}
 		}
 
 		protected override ConfigurationPropertyCollection Properties {
 			get { return properties; }
 		}
+
+
+		internal static MachineKeySection Config {
+			get { return WebConfigurationManager.GetSection ("system.web/machineKey") as MachineKeySection; }
+		}
+
+		private byte[] decryption_key;
+		private byte[] validation_key;
+		private SymmetricAlgorithm decryption_template;
+		private KeyedHashAlgorithm validation_template;
+
+		internal SymmetricAlgorithm GetDecryptionAlgorithm ()
+		{
+			// code location to help with unit testing the code
+			return MachineKeySectionUtils.GetDecryptionAlgorithm (Decryption);
+		}
+
+		// not to be reused outside algorithm and key validation purpose
+		private SymmetricAlgorithm DecryptionTemplate {
+			get {
+				if (decryption_template == null)
+					decryption_template = GetDecryptionAlgorithm ();
+				return decryption_template;
+			}
+		}
+
+		internal byte [] GetDecryptionKey ()
+		{
+			if (decryption_key == null)
+				SetDecryptionKey (DecryptionKey);
+			return decryption_key;
+		}
+
+		void SetDecryptionKey (string key)
+		{
+			if ((key == null) || key.StartsWith ("AutoGenerate")) {
+				decryption_key = AutoGenerate (MachineKeyRegistryStorage.KeyType.Encryption);
+			} else {
+				try {
+					decryption_key = MachineKeySectionUtils.GetBytes (key, key.Length);
+					DecryptionTemplate.Key = decryption_key;
+				}
+				catch {
+					decryption_key = null;
+					throw new ArgumentException ("Invalid key length");
+				}
+			}
+		}
+
+		internal KeyedHashAlgorithm GetValidationAlgorithm ()
+		{
+			// code location to help with unit testing the code
+			return MachineKeySectionUtils.GetValidationAlgorithm (this);
+		}
+
+		// not to be reused outside algorithm and key validation purpose
+		private KeyedHashAlgorithm ValidationTemplate {
+			get {
+				if (validation_template == null)
+					validation_template = GetValidationAlgorithm ();
+				return validation_template;
+			}
+		}
+
+		internal byte [] GetValidationKey ()
+		{
+			if (validation_key == null)
+				SetValidationKey (ValidationKey);
+			return validation_key;
+		}
+
+		// key can be expended for HMAC - i.e. a small key, e.g. 32 bytes, is still accepted as valid
+		// the HMAC class already deals with keys larger than what it can use (digested to right size)
+		void SetValidationKey (string key)
+		{
+			if ((key == null) || key.StartsWith ("AutoGenerate")) {
+				validation_key = AutoGenerate (MachineKeyRegistryStorage.KeyType.Validation);
+			} else {
+				try {
+					validation_key = MachineKeySectionUtils.GetBytes (key, key.Length);
+					ValidationTemplate.Key = validation_key;
+				}
+				catch (CryptographicException) {
+					// second chance, use the key length that the HMAC really wants
+					try {
+						byte[] expanded_key = new byte [ValidationTemplate.Key.Length];
+						Array.Copy (validation_key, 0, expanded_key, 0, validation_key.Length);
+						ValidationTemplate.Key = expanded_key;
+						validation_key = expanded_key;
+					}
+					catch {
+						validation_key = null;
+						throw new ArgumentException ("Invalid key length");
+					}
+				}
+			}
+		}
+
+		byte[] AutoGenerate (MachineKeyRegistryStorage.KeyType type)
+		{
+			byte[] key = null;
+#if TARGET_J2EE
+			{
+#else
+			try {
+				key = MachineKeyRegistryStorage.Retrieve (type);
+
+				// ensure the stored key is usable with the selection algorithm
+				if (type == MachineKeyRegistryStorage.KeyType.Encryption)
+					DecryptionTemplate.Key = key;
+				else if (type == MachineKeyRegistryStorage.KeyType.Validation)
+					ValidationTemplate.Key = key;
+			} catch (Exception) {
+				key = null;
+			}
+#endif
+			// some algorithms have special needs for key (e.g. length, parity, weak keys...) 
+			// so we better ask them to provide a default key (than to generate/use bad ones)
+			if (key == null) {
+				if (type == MachineKeyRegistryStorage.KeyType.Encryption)
+					key = DecryptionTemplate.Key;
+				else if (type == MachineKeyRegistryStorage.KeyType.Validation)
+					key = ValidationTemplate.Key;
+#if !TARGET_J2EE
+				MachineKeyRegistryStorage.Store (key, type);
+#endif
+			}
+			return key;
+		}
 	}
 }
 
diff --git a/mcs/class/System.Web/System.Web.Configuration_2.0/MachineKeyValidationConverter.cs b/mcs/class/System.Web/System.Web.Configuration_2.0/MachineKeyValidationConverter.cs
index 014ca28..698509c 100644
--- a/mcs/class/System.Web/System.Web.Configuration_2.0/MachineKeyValidationConverter.cs
+++ b/mcs/class/System.Web/System.Web.Configuration_2.0/MachineKeyValidationConverter.cs
@@ -3,8 +3,9 @@
 //
 // Authors:
 //	Chris Toshok (toshok@ximian.com)
+//	Sebastien Pouliot  <sebastien@ximian.com>
 //
-// (c) Copyright 2005 Novell, Inc (http://www.novell.com)
+// Copyright (C) 2005, 2010 Novell, Inc (http://www.novell.com)
 //
 
 //
@@ -28,7 +29,6 @@
 // WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 //
 
-using System;
 using System.ComponentModel;
 using System.Configuration;
 using System.Globalization;
@@ -39,40 +39,76 @@ namespace System.Web.Configuration {
 
 	public sealed class MachineKeyValidationConverter : ConfigurationConverterBase
 	{
+#if NET_4_0
+		const string InvalidValue = "The enumeration value must be one of the following: SHA1, MD5, 3DES, AES, HMACSHA256, HMACSHA384, HMACSHA512."; 
+#else
+		const string InvalidValue = "The enumeration value must be one of the following: SHA1, MD5, 3DES, AES."; 
+#endif
 		public MachineKeyValidationConverter ()
 		{
 		}
 
 		public override object ConvertFrom (ITypeDescriptorContext ctx, CultureInfo ci, object data)
 		{
-			if ((string)data == "MD5")
+			switch ((string) data) {
+			case "MD5":
 				return MachineKeyValidation.MD5;
-			else if ((string)data == "SHA1")
+			case "SHA1":
 				return MachineKeyValidation.SHA1;
-			else if ((string)data == "3DES")
+			case "3DES":
 				return MachineKeyValidation.TripleDES;
-			else if ((string)data == "AES")
+			case "AES":
 				return MachineKeyValidation.AES;
-			else
-				throw new ArgumentException ("The enumeration value must be one of the following: SHA1, MD5, 3DES, AES.");
+#if NET_4_0
+			case "HMACSHA256":
+				return MachineKeyValidation.HMACSHA256;
+			case "HMACSHA384":
+				return MachineKeyValidation.HMACSHA384;
+			case "HMACSHA512":
+				return MachineKeyValidation.HMACSHA512;
+#endif
+			default:
+				throw new ArgumentException (InvalidValue);
+			}
 		}
 
 		public override object ConvertTo (ITypeDescriptorContext ctx, CultureInfo ci, object value, Type type)
 		{
+#if NET_4_0
+			if ((value == null) || (value.GetType () != typeof (MachineKeyValidation)))
+				throw new ArgumentException (InvalidValue);
+#else
 			if (value.GetType () != typeof (MachineKeyValidation)) {
 				/* MS throws this exception on an invalid */
-				throw new FormatException ("invalid validation value");
+				throw new FormatException (InvalidValue);
 			}				
+#endif
 
-			MachineKeyValidation v = (MachineKeyValidation)value;
-
-			if (v == MachineKeyValidation.MD5) return "MD5";
-			else if (v == MachineKeyValidation.SHA1) return "SHA1";
-			else if (v == MachineKeyValidation.TripleDES) return "3DES";
-			else if (v ==  MachineKeyValidation.AES) return "AES";
-			else
+			switch ((MachineKeyValidation) value) {
+			case MachineKeyValidation.MD5:
+				return "MD5";
+			case MachineKeyValidation.SHA1:
+				return "SHA1";
+			case MachineKeyValidation.TripleDES:
+				return "3DES";
+			case MachineKeyValidation.AES:
+				return "AES";
+#if NET_4_0
+			case MachineKeyValidation.HMACSHA256:
+				return "HMACSHA256";
+			case MachineKeyValidation.HMACSHA384:
+				return "HMACSHA384";
+			case MachineKeyValidation.HMACSHA512:
+				return "HMACSHA512";
+			default:
+				// includes MachineKeyValidation.Custom
+				throw new ArgumentException (InvalidValue);
+#else
+			default:
 				/* MS throws this exception on an invalid */
-				throw new FormatException ("invalid validation value");
+				throw new FormatException (InvalidValue);
+#endif
+			}
 		}
 	}
 }
diff --git a/mcs/class/System.Web/System.Web.Handlers/AssemblyResourceLoader.cs b/mcs/class/System.Web/System.Web.Handlers/AssemblyResourceLoader.cs
index c8acba1..8953b71 100644
--- a/mcs/class/System.Web/System.Web.Handlers/AssemblyResourceLoader.cs
+++ b/mcs/class/System.Web/System.Web.Handlers/AssemblyResourceLoader.cs
@@ -34,7 +34,6 @@ using System.Reflection;
 using System.IO;
 using System.Resources;
 using System.Collections;
-using System.Security.Cryptography;
 using System.Text;
 using System.Text.RegularExpressions;
 using System.Web.Configuration;
@@ -59,11 +58,6 @@ namespace System.Web.Handlers {
 		const char QueryParamSeparator = '&';
 
 		static readonly Hashtable _embeddedResources = Hashtable.Synchronized (new Hashtable ());
-#if SYSTEM_WEB_EXTENSIONS
-		static ScriptResourceHandler () {
-			MachineKeySectionUtils.AutoGenKeys ();
-		}
-#endif
 
 		static void InitEmbeddedResourcesUrls (Assembly assembly, Hashtable hashtable)
 		{
@@ -92,70 +86,40 @@ namespace System.Web.Handlers {
 		{
 			return GetResourceUrl (type.Assembly, resourceName, false);
 		}
-#endif
-
-		static string GetHexString (byte [] bytes)
-		{
-			const int letterPart = 55;
-			const int numberPart = 48;
-			char [] result = new char [bytes.Length * 2];
-			for (int i = 0; i < bytes.Length; i++) {
-				int tmp = (int) bytes [i];
-				int second = tmp & 15;
-				int first = (tmp >> 4) & 15;
-				result [(i * 2)] = (char) (first > 9 ? letterPart + first : numberPart + first);
-				result [(i * 2) + 1] = (char) (second > 9 ? letterPart + second : numberPart + second);
-			}
-			return new string (result);
-		}
-		
-		static byte[] GetEncryptionKey ()
-		{
-#if NET_2_0
-			return MachineKeySectionUtils.DecryptionKey192Bits ();
-#else
-			MachineKeyConfig config = HttpContext.GetAppConfig ("system.web/machineKey") as MachineKeyConfig;
-			return config.DecryptionKey192Bits;
-#endif
-		}
-
-		static byte[] GetBytes (string val)
+#endif		
+		static string EncryptAssemblyResource (string asmName, string resName)
 		{
+			byte[] bytes = Encoding.UTF8.GetBytes (String.Concat (asmName, ";", resName));
+			bytes = MachineKeySectionUtils.Encrypt (
 #if NET_2_0
-			return MachineKeySectionUtils.GetBytes (val, val.Length);
+				MachineKeySection.Config,
 #else
-			return MachineKeyConfig.GetBytes (val, val.Length);
+				MachineKeyConfig.Config,
 #endif
-		}		
-		
-		static byte [] init_vector = { 0xD, 0xE, 0xA, 0xD, 0xB, 0xE, 0xE, 0xF };
-		
-		static string EncryptAssemblyResource (string asmName, string resName)
-		{
-			byte[] key = GetEncryptionKey ();
-			byte[] bytes = Encoding.UTF8.GetBytes (String.Concat (asmName, ";", resName));
-			string result;
-			
-			ICryptoTransform encryptor = TripleDES.Create ().CreateEncryptor (key, init_vector);
-			result = GetHexString (encryptor.TransformFinalBlock (bytes, 0, bytes.Length));
-			bytes = null;
-
-			return String.Concat ("d=", result.ToLower (Helpers.InvariantCulture));
+				bytes);
+			return Convert.ToBase64String (bytes);
 		}
 
 		static void DecryptAssemblyResource (string val, out string asmName, out string resName)
 		{
-			byte[] key = GetEncryptionKey ();
-			byte[] bytes = GetBytes (val);
-			byte[] result;
+			byte[] bytes = Convert.FromBase64String (val);
 
 			asmName = null;
 			resName = null;			
 
-			ICryptoTransform decryptor = TripleDES.Create ().CreateDecryptor (key, init_vector);
-			result = decryptor.TransformFinalBlock (bytes, 0, bytes.Length);
+			byte[] result = MachineKeySectionUtils.Decrypt (
+#if NET_2_0
+				MachineKeySection.Config,
+#else
+				MachineKeyConfig.Config,
+#endif
+				bytes);
 			bytes = null;
 
+			// null will be returned if, for any reason, decryption fails
+			if (result == null)
+				return;
+
 			string data = Encoding.UTF8.GetString (result);
 			result = null;
 
@@ -202,7 +166,7 @@ namespace System.Web.Handlers {
 			if (apath != String.Empty)
 				atime = String.Concat (QueryParamSeparator, "t=", File.GetLastWriteTimeUtc (apath).Ticks);
 #endif
-			string href = HandlerFileName + "?" + EncryptAssemblyResource (aname, resourceName) + atime + extra;
+			string href = HandlerFileName + "?d=" + EncryptAssemblyResource (aname, resourceName) + atime + extra;
 
 			HttpContext ctx = HttpContext.Current;
 			if (ctx != null && ctx.Request != null) {
